// bxtest.c
//
// Demonstrates the ButtonEx Control.
//
// John Findlay
//
// Link with wlib.lib

#include <windows.h>
#include <stdio.h>
#include "resource.h"
#include "buttonex.h"

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

HWND 	  hWnd;
HINSTANCE hInst;
HBITMAP hBmp, hBmp1, hBmp2, hBmp3, hBmp4, hBmp5;

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrev, LPSTR lpCmdLine, int nCmdShow)
{
	MSG					msg;
	WNDCLASS			wc;
	HFONT hFont;

	hFont = CreateFont(16, 0, 0, 0, FW_DONTCARE, FALSE, 0,
				0, (DWORD)DEFAULT_CHARSET, 0, 0, 0, 0, "MS Sans Serif"); // Helv

	hInst = hInstance;

	wc.style			= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc		= (WNDPROC)MainWndProc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(1));
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_BTNFACE + 1);
	wc.lpszMenuName		= MAKEINTRESOURCE(ID_MENU);
	wc.lpszClassName	= "main";

	if (!RegisterClass(&wc))
		return 0;

	// create main window
	hWnd = CreateWindowEx(WS_EX_CLIENTEDGE, "main", "ButtonEx Demo...",
		WS_OVERLAPPEDWINDOW,
		40,40,
		620,460,
		NULL,
		(HMENU)0,
		hInstance,
		NULL);

	if (hWnd == NULL)
	{
		MessageBox(NULL, "Not today!", "Message", MB_OK | MB_APPLMODAL);
		return 0;
	}
HWND h;

	h = CreateButtonEx("Bit&map Button",
				WS_VISIBLE | BXS_TABSTOP | BXS_FOCUSRECT | BXS_LEFTTEXT | BXS_BITMAP,
				10, 10, 140, 44, hWnd, 1);

	Butx_SetCursor(h, LoadCursor(hInstance, MAKEINTRESOURCE(7)));

	// load bitmaps and convert the background colour to white
	hBmp = LoadConvertBitmapCols(3, RGB(128,40,136), RGB(128,128,255));
	hBmp1 = LoadConvertBitmapCols(4, RGB(128,40,136), RGB(128,128,255));

	// set images and set background color
	SendMessage(h, BXM_SETBKCOLOR, 0, RGB(128,128,255));
	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp);
	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp1);

	EnableWindow(h, FALSE);

	// create second button
	h = CreateButtonEx("Icon Button",
			WS_VISIBLE | BXS_FOCUSRECT | BXS_TABSTOP | BXS_ICON,
			10, 60, 140, 44, hWnd, 2);

	// load icons
	HICON hIco = LoadIcon(hInstance, MAKEINTRESOURCE(1));
	HICON hIco1 = LoadIcon(hInstance, MAKEINTRESOURCE(2));

	// set icons
	SendMessage(h, BXM_SETIMAGE, IMAGE_ICON, (long)hIco);
	SendMessage(h, BXM_SETIMAGE, IMAGE_ICON, (long)hIco1);

	EnableWindow(h, FALSE);

	InitButtonEx();
	// create third button with CreateWindow
	h = CreateWindow(BUTTONEX, "&XP Focus",
		BXS_TABSTOP | WS_CHILD | WS_VISIBLE | BXS_XP | BXS_FOCUSRECT,
		10, 109, 100, 34, hWnd, (HMENU)3, hInstance, NULL);

	SendMessage(h, BXM_SETBKCOLOR, 0, RGB(248,0,0));

	// create fourth button with CreateWindow
	h = CreateWindow(BUTTONEX, "X&P Button",
		BXS_TABSTOP | WS_CHILD | WS_VISIBLE | BXS_XP,
		10, 150, 100, 34, hWnd, (HMENU)4, hInstance, NULL);

	// create fith button with BXS_LITE
	h = CreateWindow(BUTTONEX, "&Lite Button",
		BXS_TABSTOP | BXS_FOCUSRECT | WS_CHILD | WS_VISIBLE | BXS_LITE,
		10, 190, 130, 30, hWnd, (HMENU)5, hInstance, NULL);

	// set the back colour
	SendMessage(h, BXM_SETBKCOLOR, 0, RGB(192,200,200));

	// create sixth button with a full image no text
	h = CreateWindow(BUTTONEX, "",
		BXS_NOSYSCOLORCHANGE | WS_CHILD | WS_VISIBLE | BXS_BITMAP | BXS_BMPONLY,
		160, 10, 64, 71, hWnd, (HMENU)6, hInstance, NULL);

	hBmp2 = LoadBitmap(hInst, MAKEINTRESOURCE(5));
	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp2);

	hBmp3 = LoadBitmap(hInst, MAKEINTRESOURCE(6));
	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp3);

	// create next button with a full image no text and border
	h = CreateWindow(BUTTONEX, "",
		BXS_NOSYSCOLORCHANGE | WS_CHILD | WS_VISIBLE | BXS_BITMAP | BXS_BMPONLY,
		240, 6, 74, 81, hWnd, (HMENU)7, hInstance, NULL);

	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp2);
	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp3);

	Butx_AddToolTipText(h, "Tooltip Text");

	h = CreateButtonEx("Icon Top Text", WS_VISIBLE | BXS_TOPTEXT | BXS_ICON,
				160, 100, 110, 70, hWnd, 8);

	SendMessage(h, BXM_SETIMAGE, IMAGE_ICON, (long)hIco);
	SendMessage(h, BXM_SETIMAGE, IMAGE_ICON, (long)hIco1);

	h = CreateButtonEx("Icon Bottom Text", WS_VISIBLE | BXS_BOTTOMTEXT | BXS_BORDER | BXS_ICON,
				280, 100, 110, 70, hWnd, 9);

	SendMessage(h, BXM_SETIMAGE, IMAGE_ICON, (long)hIco);
	SendMessage(h, BXM_SETIMAGE, IMAGE_ICON, (long)hIco1);

	h = CreateButtonEx("Bitmap Top Text", WS_VISIBLE | BXS_TOPTEXT | BXS_BITMAP,
				10, 230, 140, 60, hWnd, 10);

	hBmp4 = LoadConvertBitmapCols(3, RGB(128,40,136), GetSysColor(COLOR_BTNFACE));
	hBmp5 = LoadConvertBitmapCols(4, RGB(128,40,136), GetSysColor(COLOR_BTNFACE));

	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp4);
	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp5);

	h = CreateButtonEx("Bitmap Bottom Text", WS_VISIBLE | BXS_BOTTOMTEXT | BXS_BORDER | BXS_BITMAP,
				10, 300, 140, 60, hWnd, 11);

	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp4);
	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp5);

	Butx_AddToolTipText(h, "Tooltip\r\nText");


	h = CreateWindow("button", "BXS_TOOL ",
		WS_CHILD | WS_VISIBLE | BS_GROUPBOX,
		154, 178, 214, 88, hWnd, (HMENU)12, hInstance, NULL);

	SendMessage(h, WM_SETFONT, (WPARAM)hFont, 0);

	h = CreateButtonEx("&Button 12",
				WS_VISIBLE | BXS_TOOL | BXS_BOTTOMTEXT | BXS_LITE | BXS_BITMAP,
				160, 200, 100, 60, hWnd, 13);

	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp4);
	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp5);

	h = CreateButtonEx("Button 13",
				WS_VISIBLE | BXS_TOOL | BXS_BOTTOMTEXT | BXS_LITE | BXS_BITMAP,
				260, 200, 100, 60, hWnd, 14);

	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp4);
	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp5);

	h = CreateWindow("button", "BXS_TOOL | BXS_TOOLGROUP ",
		WS_CHILD | WS_VISIBLE | BS_GROUPBOX,
		154, 278, 314, 88, hWnd, (HMENU)15, hInstance, NULL);

	SendMessage(h, WM_SETFONT, (WPARAM)hFont, 0);

	h = CreateButtonEx("Button 14",
				WS_VISIBLE | BXS_TOOL | BXS_TOOLGROUP | BXS_BOTTOMTEXT | BXS_LITE | BXS_BITMAP,
				160, 300, 100, 60, hWnd, 16);

	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp4);
	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp5);

	h = CreateButtonEx("B&utton 15",
				WS_VISIBLE | BXS_NORMAL | BXS_TOOLGROUP | BXS_TOOL | BXS_BOTTOMTEXT | BXS_LITE | BXS_BITMAP,
				261, 300, 100, 60, hWnd, 17);

	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp4);
	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp5);

	h = CreateButtonEx("Button 16",
				WS_VISIBLE | BXS_TOOLGROUP | BXS_BOTTOMTEXT | BXS_LITE | BXS_BITMAP,
				362, 300, 100, 60, hWnd, 18);

	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp4);
	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp5);

	Butx_SetToolGroup(GetDlgItem(hWnd, 19));

	h = CreateButtonEx("Normal Button Border",
			WS_VISIBLE | BXS_NORMAL | BXS_BOTTOMTEXT | BXS_LITE | BXS_BITMAP | BXS_TABSTOP | BXS_FOCUSRECT,
			362, 20, 150, 60, hWnd, 20);
	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp4);
	SendMessage(h, BXM_SETIMAGE, IMAGE_BITMAP, (long)hBmp5);

	SetFocus(h); // set focus to last button created.

	ShowWindow(hWnd, SW_NORMAL);
	UpdateWindow(hWnd);

	while (GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	ExitButtonEx(); // cleanup

	if (hBmp)  DeleteObject(hBmp);
	if (hBmp1) DeleteObject(hBmp1);
	if (hBmp2) DeleteObject(hBmp2);
	if (hBmp3) DeleteObject(hBmp3);
	if (hBmp4) DeleteObject(hBmp4);
	if (hBmp5) DeleteObject(hBmp5);
	if (hFont) DeleteObject(hFont);

	return msg.wParam;
}

#define XBITMAP 80
#define YBITMAP 20

#define BUFFER MAX_PATH

HBITMAP hbmpFiller, hbmpPencil, hbmpRubber, hbmpBrush, hbmpDropper;
HBITMAP hbmpPicture, hbmpOld;

void AddItem(HWND hwnd, LPSTR lpstr, HBITMAP hbmp)
{
	int nItem;

	nItem = SendMessage(hwnd, LB_ADDSTRING, 0, (long)lpstr);
	SendMessage(hwnd, LB_SETITEMDATA, nItem, (long)hbmp);
}

BOOL _stdcall AboutDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int nItem;
	char tchBuffer[BUFFER];
	HBITMAP hbmp;
	HWND hListBox;
	TEXTMETRIC tm;
	int y;
	HDC hdcMem;
	LPMEASUREITEMSTRUCT lpmis;
	LPDRAWITEMSTRUCT lpdis;
	RECT rcBitmap;

	switch (message)
	{
		case WM_INITDIALOG:

			// Load bitmaps.
			hbmpFiller = LoadBitmap(hInst, MAKEINTRESOURCE(700));
			hbmpPencil = LoadBitmap(hInst, MAKEINTRESOURCE(701));
			hbmpRubber = LoadBitmap(hInst, MAKEINTRESOURCE(702));
			hbmpBrush = LoadBitmap(hInst, MAKEINTRESOURCE(703));
			hbmpDropper = LoadBitmap(hInst, MAKEINTRESOURCE(704));

			// Retrieve list box handle.

			hListBox = GetDlgItem(hDlg, IDL_LIST);

			// Initialize the list box text and associate a bitmap
			// with each list box item.

			AddItem(hListBox, "Filler", hbmpFiller);
			AddItem(hListBox, "Pencil", hbmpPencil);
			AddItem(hListBox, "Rubber", hbmpRubber);
			AddItem(hListBox, "Brush",    hbmpBrush);
			AddItem(hListBox, "Dropper",   hbmpDropper);

			SetFocus(hListBox);
			SendMessage(hListBox, LB_SETCURSEL, 0, 0);
			return TRUE;

		case WM_MEASUREITEM:

			lpmis = (LPMEASUREITEMSTRUCT) lParam;

			// Set the height of the list box items.

			lpmis->itemHeight = 20;
			return TRUE;

		case WM_DRAWITEM:
		lpdis = (LPDRAWITEMSTRUCT) lParam;
			// If there are no list box items, skip this message.
			if (lpdis->itemID == -1)
			{
				break;
			}

			// Draw the bitmap and text for the list box item. Draw a
			// rectangle around the bitmap if it is selected.

			switch (lpdis->itemAction)
			{
				case ODA_SELECT:
				case ODA_DRAWENTIRE:
					// Display the bitmap associated with the item.
					hbmpPicture =(HBITMAP)SendMessage(lpdis->hwndItem,
										LB_GETITEMDATA, lpdis->itemID, (LPARAM) 0);

					hdcMem = CreateCompatibleDC(lpdis->hDC);
					hbmpOld = SelectObject(hdcMem, hbmpPicture);

					BitBlt(lpdis->hDC, lpdis->rcItem.left, lpdis->rcItem.top,
									lpdis->rcItem.right - lpdis->rcItem.left,
									lpdis->rcItem.bottom - lpdis->rcItem.top,
									hdcMem, 0, 0, SRCCOPY);

					// Display the text associated with the item.

					SendMessage(lpdis->hwndItem, LB_GETTEXT, lpdis->itemID, (LPARAM) tchBuffer);

					GetTextMetrics(lpdis->hDC, &tm);

					y = (lpdis->rcItem.bottom + lpdis->rcItem.top - tm.tmHeight) / 2;

					TextOut(lpdis->hDC, XBITMAP + 6, y, tchBuffer, strlen(tchBuffer));

					SelectObject(hdcMem, hbmpOld);
					DeleteDC(hdcMem);

					// Is the item selected?

					if (lpdis->itemState & ODS_SELECTED)
					{
						// Set RECT coordinates to surround only the
						// bitmap.

						rcBitmap.left = lpdis->rcItem.left;
						rcBitmap.top = lpdis->rcItem.top;
						rcBitmap.right = lpdis->rcItem.left + XBITMAP;
						rcBitmap.bottom = lpdis->rcItem.top + YBITMAP;

						// Draw a rectangle around bitmap to indicate
						// the selection.
						DrawFocusRect(lpdis->hDC, &rcBitmap);
					}
					break;

				case ODA_FOCUS:
					// Do not process focus changes. The focus caret
					// (outline rectangle) indicates the selection.
					// The IDOK button indicates the final
					// selection.
					break;
			}
			return TRUE;

		case WM_COMMAND:

			switch (LOWORD(wParam))
			{
				case IDOK:
					// Get the selected item's text.
					nItem = SendMessage(GetDlgItem(hDlg, IDL_LIST),
					LB_GETCURSEL, 0, (LPARAM) 0);
					hbmp = (HBITMAP)SendMessage(GetDlgItem(hDlg, IDL_LIST),
							LB_GETITEMDATA, nItem, 0);

					// If the item is not the correct answer, tell the
					// user to try again.
					//
					// If the item is the correct answer, congratulate
					// the user and destroy the dialog box.
					if (hbmp != hbmpDropper)
					{
						MessageBox(hDlg, "Try again!", "Oops", MB_OK);
						return FALSE;
					}
					else
					{
						MessageBox(hDlg, "You're right!",  "Congratulations.", MB_OK);
					// Fall through.
					}

				case IDCANCEL:
					// Destroy the dialog box.
					EndDialog(hDlg, TRUE);
					return TRUE;

				default:

					return FALSE;
			}

		case WM_DESTROY:
			// Free any resources used by the bitmaps.
			DeleteObject(hbmpFiller);
			DeleteObject(hbmpPencil);
			DeleteObject(hbmpRubber);
			DeleteObject(hbmpBrush);
			DeleteObject(hbmpDropper);

			return TRUE;

		default:
			return FALSE;

	}
	return FALSE;
}

/*
BOOL _stdcall AboutDlg(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg){
	case WM_INITDIALOG:
		// set colours for dialog button
		Butx_SetTextColor(GetDlgItem(hDlg, 201), RGB(0,0,255));
		return 1;

	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case 201:
			EndDialog(hDlg,0);
			break;
		}
		break;
	case WM_CLOSE:
		EndDialog(hDlg,0);
		return 1;
	}
	return 0;
}
*/
char mess[] = "Button CtrlID";
char ss[90];
PAINTSTRUCT ps;
LRESULT CALLBACK MainWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message){
		// If WM_SYSCOLORCHANGE happens call Butx_SysColorChange().
		// Child windows do not receive this message from the system
		// so it must be done this way.
	case WM_SYSCOLORCHANGE:
		Butx_SysColorChange(hWnd);
		break;

	case WM_SYSKEYUP:
		return 0;

	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case IDM_DIAG:
			InitButtonEx();
			DialogBox(hInst, MAKEINTRESOURCE(DLG_100), hWnd, AboutDlg);
			break;
		case 1:	 case 2:  case 3:  case 4:  case 5:  case 6:  case 7:  case 8:
		case 9: case 10: case 11: case 12: case 13:	case 14: case 15: case 16: case 17:
			sprintf(ss, "%s = %d", mess, LOWORD(wParam));
			SetWindowText(hWnd, ss);
			break;
		case IDM_ENABLE:
			Butx_SetToolGroup(GetDlgItem(hWnd, 14));
			EnableWindow(GetDlgItem(hWnd,1), TRUE);
			EnableWindow(GetDlgItem(hWnd,2), TRUE);
			break;
		case IDM_CHANGESTYLE:
			Butx_Style(GetDlgItem(hWnd,11), BXS_TOPTEXT | BXS_BITMAP);
			//SetWindowLong(GetDlgItem(hWnd,11), GWL_STYLE, WS_CHILD | WS_VISIBLE | BXS_TOPTEXT | BXS_BITMAP);
			break;
			break;

		case IDM_EXIT:
			PostMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		}
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}

	return DefWindowProc(hWnd, message, wParam, lParam);
}


