// listboxex.h
//
// John Findlay
//

#ifndef _LBX_H_
#define _LBX_H_

#include <windows.h>

// styles
#define LBXS_BORDER 			0x800000
#define LBXS_NOCLICKHEADER  	0x8000
#define LBXS_NOCOLUMNHEADER 	0x4000
#define LBXS_NOSCROLL           0x2000
#define LBXS_SHOWSELALWAYS  	0x8
#define LBXS_SINGLESEL  		0x4
#define LBXS_SUNKEN 			0x200

// extended styles
#define LBXS_EX_GRIDLINES		0x1
#define LBXS_EX_CHECKBOXES      0x4
#define LBXS_EX_FULLROWSELECT	0x20
#define LBXS_EX_NOTIFYCLICK     0x40
#define LBXS_EX_NOTIFYDBCLICK   0x80
#define LBXS_EX_NOTIFYHIGHLITE  0x4000
#define LBXS_EX_TOOLTIP         0x400

// notify messages
#define LBXN_CLICK          0x80AD  // can be double clicks or single clicks
#define LBXN_HDRCLICK		0x80AE  // notification of header button clicks
#define LBXN_TTTEXT         0x80AF
#define LBXN_HIGHLITE       0x80B0

// main creation API
HWND CreateListBoxEx( DWORD dwExStyle, DWORD dwStyle, int x, int y, int cx, int cy, HWND hWndParent, int numcols, DWORD ctrlID );

// Functions
BOOL     Lbx_GetCheckMark( HWND hwndLbx, int index );
void     Lbx_SetCheckMark( HWND hwndLbx, int index, BOOL fCheck );
int 	 Lbx_GetHighItem( HWND hwndLbx );
int      Lbx_GetTopSel( HWND hwndLbx );
BOOL     Lbx_GetItemState( HWND hwndLbx, int row );
void     Lbx_SetSelected( HWND hwndLbx, int row, BOOL fCheck );
int      Lbx_AddRowAll( HWND hwndLbx, int nCols, char ** str );
int      Lbx_AddRow( HWND hwndLbx, char * str );
void     Lbx_AddItem( HWND hwndLbx, int row, int item, char * str );
void     Lbx_DeleteAllRows( HWND hwndLbx );
int      Lbx_DeleteRow( HWND hwndLbx, int row );
int      Lbx_FindRow( HWND hwndLbx, int istart, char * str );
COLORREF Lbx_GetBkColor( HWND hwndLbx );
int      Lbx_GetColWidth( HWND hwndLbx, int icol );
int      Lbx_GetCurSel( HWND hwndLbx );
HANDLE   Lbx_GetFont( HWND hwndLbx );
void     Lbx_GetItemText( HWND hwndLbx, int row, int col, char * str, int buffsize );
int      Lbx_GetRowCount( HWND hwndLbx );
void     Lbx_GetRowText( HWND hwndLbx, int nCols, int row, char ** str, int bufsize );
int      Lbx_GetRowTextBuffer( HWND hwndLbx, int nCols, int row, char * str, int bufsize, char * wkbuf, int wkbufsize, char sep );
int      Lbx_GetRowsPerPage( HWND hwndLbx );
int      Lbx_GetSelCount( HWND hwndLbx );
int      Lbx_GetStringWidth( HWND hwndLbx, char * str );
COLORREF Lbx_GetTextColor( HWND hwndLbx );
int      Lbx_InsertRow( HWND hwndLbx, int row, char * str );
int      Lbx_InsertRowAll( HWND hwndLbx, int nCols, int row, char ** str );
BOOL     Lbx_Scroll( HWND hwndLbx, int dx, int dy );
void     Lbx_SetBkColor( HWND hwndLbx, COLORREF colref );
void     Lbx_SetColHeadTxt( HWND hwndLbx, int iCol, char * str );
void     Lbx_SetColHeadTxtAll( HWND hwndLbx, int nCols, char ** str );
void     Lbx_SetColWidth( HWND hwndLbx, int iCol, int width );
void     Lbx_SetColWidthAll( HWND hwndLbx, int nCols, int * width );
void     Lbx_SetFont( HWND hwndLbx, HANDLE hFont );
void     Lbx_SetTextColor( HWND hwndLbx, COLORREF colref );
void     Lbx_ShowWindow( HWND hwndLbx, DWORD show );
void     Lbx_SortRows( HWND hwndLbx );
void     Lbx_SortRowsEx( HWND hwndLbx, int (*comp)(int, int, int), long lval );
int      Lbx_TopVisibleRow( HWND hwndLbx );
void     Lbx_Update( HWND hwndLbx );
void     Lbx_libvers();

#endif
